#include <stdio.h>
#include <stdlib.h>
#define MAXN 100000

static int hrany[3 * MAXN][2];
static int n, m;
static int perm[MAXN];

static void
gen_random (int an)
{
  int deg[an];
  int nbrs[an][6];
  int i;

  n = an;
  for (i = 0; i < an; i++)
    deg[i] = 0;

  for (i = 0; i < 6 * MAXN; i++)
    {
      int f, t, j;

      f = rand () % an;
      t = rand () % an;

      if (f == t || deg[f] >= 6 || deg[t] >= 6)
	continue;

      for (j = 0; j < deg[f]; j++)
	if (nbrs[f][j] == t)
	  break;
      if (j < deg[f])
	continue;

      nbrs[f][deg[f]++] = t;
      nbrs[t][deg[t]++] = f;
      hrany[m][0] = f;
      hrany[m][1] = t;
      m++;
    }
}

static void
writeout (FILE *fout)
{
  int i;
  for (i = 0; i < n; i++)
    perm[i] = i + 1;
  for (i = 0; i < n; i++)
    {
      int w = i + rand () % (n - i), a;
      a = perm[i];
      perm[i] = perm[w];
      perm[w] = a;
    }

  fprintf (fout, "%d %d\n", n, m);
  for (i = 0; i < m; i++)
    fprintf (fout, "%d %d\n", perm[hrany[i][0]], perm[hrany[i][1]]);
}

int main (int argc, char *argv[])
{
  int vstn = atoi (argv[1]);
  char name[100];
  FILE *fout;
  int i;

  sprintf (name, "p1-3.%d", vstn);
  fout = fopen (name, "w");
  srand (0);

  switch (vstn)
    {
    case 1:
      /* vzorovy vstup */
      fprintf (fout, "5 6\n1 2\n1 3\n1 4\n1 5\n3 2\n4 2\n");
      break;

    case 2:
      /* Male dvojite kolo.  */
      n = 1000;
      for (i = 0; i < n - 2; i++)
	{
	  hrany[m][0] = i;
	  hrany[m][1] = (i + 1) % (n - 2);
	  m++;
	  hrany[m][0] = i;
	  hrany[m][1] = n - 2;
	  m++;
	  hrany[m][0] = i;
	  hrany[m][1] = n - 1;
	  m++;
	}
      writeout (fout);
      break;

    case 3:
      /* Izolovane vrcholy.  */
      fprintf (fout, "5 0\n");
      break;

    case 4:
      /* Nahodny graf s max. degree <= 6.  */
      gen_random (1000);
      writeout (fout);
      break;

    case 5:
      /* Klika velikosti 7.  */
      n = 7;
      for (i = 0; i < 7; i++)
	{
	  int j;
	  for (j = i + 1; j < 7; j++)
	    {
	      hrany[m][0] = i;
	      hrany[m][1] = j;
	      m++;
	    }
	}
      writeout (fout);
      break;

    case 6:
      /* Dvojite kolo.  */
      n = MAXN;
      for (i = 0; i < n - 2; i++)
	{
	  hrany[m][0] = i;
	  hrany[m][1] = (i + 1) % (n - 2);
	  m++;
	  hrany[m][0] = i;
	  hrany[m][1] = n - 2;
	  m++;
	  hrany[m][0] = i;
	  hrany[m][1] = n - 1;
	  m++;
	}
      writeout (fout);
      break;

    case 7:
      /* Kolo + navesene kliky.  */
      n = 351;
      for (i = 1; i <= 350; i++)
	{
	  hrany[m][0] = 0;
	  hrany[m][1] = i;
	  m++;
	  hrany[m][0] = i % 350 + 1;
	  hrany[m][1] = i;
	  m++;
	}
      for (i = 1; i <= 350; i++)
	{
	  int j;

	  for (j = 0; j < 100; j++)
	    {
	      int k = ((i + j) % 4) + 1, a, b;

	      for (a = 0; a < k; a++)
		{
		  hrany[m][0] = i;
		  hrany[m][1] = n + a;
		  m++;
		  for (b = a + 1; b < k; b++)
		    {
		      hrany[m][0] = n + b;
		      hrany[m][1] = n + a;
		      m++;
		    }
		}
	      n += k;
	    }
	}
      writeout (fout);
      break;

    case 8:
      /* Hvezda z klik.  */
      n = 1;
      for (i = 0; i < 39999; i++)
	{
	  int k = i % 4 + 1, a, b;

      	  for (a = 0; a < k; a++)
	    {
	      hrany[m][0] = 0;
	      hrany[m][1] = n + a;
	      m++;
	      for (b = a + 1; b < k; b++)
		{
	     	  hrany[m][0] = n + b;
		  hrany[m][1] = n + a;
		  m++;
		}
	    }
	  n += k;
	}
      writeout (fout);
      break;

    case 9:
      /* Nahodny graf s max. degree <= 6.  */
      gen_random (MAXN);
      writeout (fout);
      break;

    case 10:
      /* K_{3,n-3} + trojuhelnik.  */
      n = MAXN;
      hrany[m][0] = 0;
      hrany[m][1] = 1;
      m++;
      hrany[m][0] = 0;
      hrany[m][1] = 2;
      m++;
      hrany[m][0] = 1;
      hrany[m][1] = 2;
      m++;
      for (i = 3; i < MAXN; i++)
	{
	  hrany[m][0] = 0;
	  hrany[m][1] = i;
	  m++;
	  hrany[m][0] = 1;
	  hrany[m][1] = i;
	  m++;
	  hrany[m][0] = 2;
	  hrany[m][1] = i;
	  m++;
	}
      writeout (fout);
      break;
    }
  return 0;
}
