#include <stdio.h>
#include <stdlib.h>
#include <set>

#define MAXN 100000
#define MAXM 600000
#define MAXCLIQUE 7

using namespace std;

set<int> Neighbors[MAXN]; //Neighbors[i] je mnozina sousedu vrcholu i
set<pair<int, int> > DegreeSet; //pro kazdy vrchol i obsahuje dvojici (Degree[i], i)
int Degree[MAXN]; //Degree[i] je aktualni stupen vrcholu i

int main()
{
	int n, m;
	scanf("%d%d", &n, &m);
	
	int v1, v2;
	for(int i = 0; i < m; i++)
	{
		scanf("%d%d", &v1, &v2);
		v1--;
		v2--;
		
		Neighbors[v1].insert(v2);
		Neighbors[v2].insert(v1);
		Degree[v1]++;
		Degree[v2]++;
	}
	
	for(int i = 0; i < n; i++)
	{
		DegreeSet.insert(make_pair(Degree[i], i));
	}
	
	int size = 1; //velikost nejvetsi nalezene kliky
	int clique[MAXCLIQUE] = {0}; //jeji vrcholy
	
	while(!(DegreeSet.empty()))
	{
		set<pair<int, int> >::iterator it = DegreeSet.begin();
		int vertex = it->second; //aktualni vrchol s nejnizsim stupnem
		int neighbor[MAXCLIQUE]; //jeho sousedi
		int d = 0; //jeho stupen
		for(set<int>::iterator it2 = Neighbors[vertex].begin(); it2 != Neighbors[vertex].end(); it2++)
		{
			neighbor[d++] = *it2;
		}
		
		DegreeSet.erase(it);
		
		for(int mask = 0; mask < 1 << d; mask++)
		{
			int test[MAXCLIQUE]; //aktualne proverovana skupina
			int s = 0; //pocet jejich vrcholu
			for(int i = 0; i < d; i++)
			{
				if(mask & (1 << i))
				{
					test[s++] = neighbor[i];
				}
			}
			
			if(s < size)
			{
				continue;
			}
			
			int ok = 1;
			for(int i = 0; (i < s) && (ok); i++)
			{
				for(int j = i + 1; (j < s) && (ok); j++)
				{
					if(Neighbors[test[i]].find(test[j]) == Neighbors[test[i]].end())
					{
						ok = 0;
					}
				}
			}
			
			if(ok)
			{
				size = s + 1;
				clique[s] = vertex;
				for(int i = 0; i < s; i++)
				{
					clique[i] = test[i];
				}
			}
		}
		
		for(int i = 0; i < d; i++)
		{
			int v = neighbor[i];
			Neighbors[v].erase(vertex);
			DegreeSet.erase(make_pair(Degree[v], v));
			Degree[v]--;
			DegreeSet.insert(make_pair(Degree[v], v));
		}
	}
	
	//printf("%d\n", size);
	for(int i = 0; i < size; i++)
	{
		printf("%d%c", clique[i] + 1, (i == size - 1) ? '\n' : ' ');
	}
	
	return 0;
}
