#include <iostream>
#include <vector>
#include <algorithm>
#define DEGEN 6
using namespace std;

/* Poet pn.  */
static unsigned n;

/* Pro kadho pina, seznam jeho znmch.  */
static vector<vector<unsigned> > spioni;

/* Seznam pin, kte jsou v poad za nm.  */
static vector<vector<unsigned> > zamnou;

/* Nalezne poad takov, aby kad znal nanejv DEGEN pn
   za nm.  */
static void
urci_poradi (void)
{
  /* Zda u byl pin odebrn.  */
  bool odebran[n + 1];
  /* Poet zbvajcch znmch.  */
  unsigned znamych[n + 1];
  /* Seznam pin s nanev DEGEN znmmi.  */
  vector<unsigned> malo;
  unsigned i;

  for (i = 1; i <= n; i++)
    {
      odebran[i] = false;
      znamych[i] = spioni[i].size();
      if (znamych[i] <= DEGEN)
	malo.push_back (i);
    }

  zamnou.resize (n + 1);
  while (!malo.empty ())
    {
      unsigned aktualni = malo.back ();
      malo.pop_back ();

      odebran[aktualni] = true;
      vector<unsigned>::iterator s = spioni[aktualni].begin ();
      vector<unsigned>::iterator se = spioni[aktualni].end ();
      for (; s < se; ++s)
	if (!odebran[*s])
	  {
	    zamnou[aktualni].push_back (*s);
	    znamych[*s]--;
	    if (znamych[*s] == DEGEN)
	      malo.push_back (*s);
	  }
    }
}

/* Zjist, zda pini S1 a S2 soused.  */

static bool
sousedi (unsigned s1, unsigned s2)
{
  for (vector<unsigned>::iterator i = zamnou[s1].begin (); i < zamnou[s1].end (); ++i)
    if (s2 == *i)
      return true;
  for (vector<unsigned>::iterator i = zamnou[s2].begin (); i < zamnou[s2].end (); ++i)
    if (s1 == *i)
      return true;
  return false;
}

/* Vrt nejvt skupinu obsahujc ZACATEK, kde ostatn leny pat do MEZI.
   Pedpokld, e prvky ZACATEK znaj vechny ostatn.  */
static vector<unsigned>
nejvetsi_skupina_mezi (vector<unsigned> zacatek, vector<unsigned> mezi)
{
  if (mezi.empty ())
    return zacatek;

  unsigned aktualni = mezi.back ();
  mezi.pop_back ();

  /* AKTUALNI bu meme pidat, nebo ne.  V prvnm ppad musme tak
     odstranit jeho nesousedy z mezi.  */
  vector<unsigned> bez = nejvetsi_skupina_mezi (zacatek, mezi);

  vector<unsigned> spolecni;
  for (vector<unsigned>::iterator mi = mezi.begin (); mi < mezi.end (); ++mi)
    if (sousedi (aktualni, *mi))
      spolecni.push_back (*mi);

  zacatek.push_back (aktualni);
  vector<unsigned> s = nejvetsi_skupina_mezi (zacatek, spolecni);

  if (s.size () < bez.size ())
    return bez;
  else
    return s;
}

/* Vrt nejvt skupinu zanajc pinem S.  */
static vector<unsigned>
nejvetsi_skupina_od (unsigned s)
{
  vector<unsigned> zacatek;
  zacatek.push_back (s);

  return nejvetsi_skupina_mezi (zacatek, zamnou[s]);
}

/* Vype skupinu V.  */
static void
vypis_skupinu (vector<unsigned> v)
{
  const char *sep = "";
  for (vector<unsigned>::iterator s = v.begin (); s < v.end (); ++s)
    {
      cout << sep << *s;
      sep = " ";
    }
  cout << endl;
}

int main(void)
{
  unsigned m, i;

  cin >> n >> m;
  spioni.resize (n + 1);
  for (i = 0; i < m; i++)
    {
      unsigned s1, s2;
      cin >> s1 >> s2;
      spioni[s1].push_back (s2);
      spioni[s2].push_back (s1);
    }
  urci_poradi ();

  vector<unsigned> skupina, ask;
  for (i = 1; i <= n; i++)
    {
      ask = nejvetsi_skupina_od (i);
      if (ask.size () > skupina.size ())
	skupina = ask;
    }

  vypis_skupinu (skupina);

  return 0;
}
