#include <stdio.h>
#include <stdlib.h>

#define DEGEN 6
#define MAXN 100000
#define HSIZE 600011

static struct edge
{
  unsigned f, t;
} hash[HSIZE];

static unsigned n;

static int
edge (unsigned f, unsigned t, int add)
{
  unsigned tmp = f, h;

  if (f > t)
    {
      f = t;
      t = tmp;
    }

  h = (f * n + t) % HSIZE;

  while (hash[h].f)
    {
      if (hash[h].f == f && hash[h].t == t)
	return 1;
      h++;
      if (h == HSIZE)
	h = 0;
    }

  if (add)
    {
      hash[h].f = f;
      hash[h].t = t;
    }

  return 0;
}

static int
test (unsigned v[], unsigned nv, unsigned *mnv, unsigned mvs[])
{
  unsigned i, av = nv - 1;

  for (i = 0; i < av; i++)
    if (!edge (v[i], v[av], 0))
      return 0;
  if (nv > *mnv)
    {
      *mnv = nv;
      for (i = 0; i < nv; i++)
	mvs[i] = v[i];
    }
  return 1;
}

int main (void)
{
  unsigned m, i;
  unsigned v[7];
  unsigned maxs = 1;
  unsigned mvs[7] = {1};
  const char *sep = "";

  scanf ("%u%u", &n, &m);
  for (i = 0; i < m; i++)
    {
      unsigned x, y;
      scanf ("%u%u", &x, &y);
      edge (x, y, 1);
    }

  for (v[0] = 1; v[0] <= n; v[0]++)
    for (v[1] = v[0] + 1; v[1] <= n; v[1]++)
      {
	if (!test (v, 2, &maxs, mvs))
	  continue;
	for (v[2] = v[1] + 1; v[2] <= n; v[2]++)
	  {
	    if (!test (v, 3, &maxs, mvs))
	      continue;
	    for (v[3] = v[2] + 1; v[3] <= n; v[3]++)
	      {
		if (!test (v, 4, &maxs, mvs))
		  continue;
		for (v[4] = v[3] + 1; v[4] <= n; v[4]++)
		  {
		    if (!test (v, 5, &maxs, mvs))
		      continue;
		    for (v[5] = v[4] + 1; v[5] <= n; v[5]++)
		      {
			if (!test (v, 6, &maxs, mvs))
			  continue;
			for (v[6] = v[5] + 1; v[6] <= n; v[6]++)
			  {
			    if (!test (v, 7, &maxs, mvs))
			      continue;
			  }
		      }
		  }
	      }
	  }
      }
  for (i = 0; i < maxs; i++)
    {
      printf ("%s%d", sep, mvs[i]);
      sep = " ";
    }
  printf ("\n");

  return 0;
}
