#include <stdio.h>
#include <vector>
#include <set>
#include <algorithm>
#define DEGEN 6
using namespace std;

/* Poet pn.  */
static unsigned n;

/* Pro kadho pina, mnozina jeho znmch.  */
static vector<set<unsigned> > spioni;

/* Otestuje, zda SK je skupina.  */
static bool
je_skupina (set<unsigned> sk)
{
  set<unsigned>::iterator i, j;

  for (i = sk.begin(); i != sk.end(); ++i)
    for (j = i, ++j; j != sk.end(); ++j)
      if (spioni[*i].count (*j) == 0)
	return false;

  return true;
}

/* vstup vystup-soutezici vystup-korektni */
int main(int argc, const char *argv[])
{
  FILE *inp, *sout, *corout;
  unsigned m, i, ans;

  inp = fopen (argv[1], "r");
  fscanf (inp, "%u%u", &n, &m);

  spioni.resize (n + 1);
  for (i = 0; i < m; i++)
    {
      unsigned s1, s2;
      fscanf (inp, "%u%u", &s1, &s2);
      spioni[s1].insert (s2);
      spioni[s2].insert (s1);
    }
  fclose (inp);

  corout = fopen (argv[3], "r");
  ans = 0;
  while (fscanf (corout, "%u", &i) == 1)
   ans++; 
  fclose (corout);

  sout = fopen (argv[2], "r");
  set<unsigned> sgrp;
  unsigned an;

  for (i = 0; i < ans; i++)
    {
      if (fscanf (sout, "%u", &an) != 1)
	{
	  fprintf (stderr, "Prilis mala skupina.\n");
	  return 1;
	}
      if (an == 0 || an > n)
	{
	  fprintf (stderr, "Chybne cislo spiona.\n");
	  return 1;
	}
      if (sgrp.count (an) != 0)
	{
	  fprintf (stderr, "Duplicitni spion.\n");
	  return 1;
	}
      sgrp.insert (an);
    }
  if (fscanf (sout, "%u", &an) == 1)
    {
      fprintf (stderr, "Prilis velka skupina.\n");
      return 1;
    }
  if (!je_skupina (sgrp))
    {
      fprintf (stderr, "Vystup neni skupina.\n");
      return 1;
    }

  return 0;
}

